import sys
import os
import cv2

# amostragem 
# parametros:
#   - imagem: imagem aberta pelo opencv
#   - xres: float entre 0 e 1 indicando a % da amostragem em X
#   - yres: idem xres mas para o eixo y.
#   - tec: string indicando qual tecnica de amostragem deve ser usada
def amostragem(imagem, xres, yres, tec):
    height, width = imagem.shape[:2]
    x_pixs_amostragem = int(1 / xres);
    y_pixs_amostragem = int(1 / yres);

    print "passos em x -> " + str(width/x_pixs_amostragem) + "(pxs por amostragem: " + str(x_pixs_amostragem) + ")"
    print "passos em y -> " + str(height/y_pixs_amostragem) + "(pxs por amostragem: " + str(y_pixs_amostragem) + ")"

    for x in range(0, width/x_pixs_amostragem):
        for y in range(0, height/y_pixs_amostragem):
            startx = x * x_pixs_amostragem
            starty = y * y_pixs_amostragem
            if tec == "media":
                total = 0
                for mx in range(startx, startx + x_pixs_amostragem):
                    for my in range(starty, starty + y_pixs_amostragem):
                        total += imagem[my, mx]
                media = total / (x_pixs_amostragem * y_pixs_amostragem)
                #print "(" + str(x) + ", " + str(y) + "): " + str(media)
                #print str(imagem[0, y*y_pixs_amostragem:x_pixs_amostragem])
                #print str(imagem[0])
                imagem[starty:starty+y_pixs_amostragem,startx:startx+x_pixs_amostragem] = media
                pass
            elif tec == "moda":
                pass
            else: # tec == mediana
                pass

# grayscale - altera a escala de tons de cinza da imagem usando uma "regra de 3" simples.
# parametros:
#   - imagem: imagem aberta pelo opencv
#   - maxgray: novo valor maximo de tons de cinza
def grayscale(imagem, maxgray):
    pass

filename = ""
x_percentage, y_percentage = 0.0, 0.0
max_gray_value = 255
tecnica = ""

tecnicas_validas = ["media", "mediana", "moda"]

if len(sys.argv) > 1:
    # Modo com parametros por CLI
    filename = sys.argv[1]
    x_percentage = float(sys.argv[2])
    y_percentage = float(sys.argv[3])
    max_gray_value = int(sys.argv[4])
    tecnica = sys.argv[5]
else:
    # Modo interativo.
    filename = raw_input("Path para a imagem: ")
    x_percentage = float(raw_input("% de amostragem horizontal entre 0 e 1: "))
    y_percentage = float(raw_input("% de amostragem vertical entre 0 e 1: "))
    max_gray_value = int(raw_input("Valor maximo de cinza: "))
    tecnica = raw_input("Qual a tecnica a ser usada [media, moda, mediana]: ")

if(x_percentage == 0 or y_percentage == 0):
    print "Erro: Um dos valores de amostragem eh 0."
    sys.exit(1)

if not os.path.isfile(filename):
    print "Erro: A imagem informada nao existe."
    sys.exit(2)

if not tecnica in tecnicas_validas:
    print "A tecnica informada nao eh reconhecida."
    print "Tecnicas reconhecidas: " + str(tecnicas_validas)
    sys.exit(3)

img = cv2.imread(filename, cv2.IMREAD_GRAYSCALE)
if img is None:
    print "Ocorreu um erro na abertura da imagem!"
    sys.exit(4)

amostragem(img, x_percentage, y_percentage, tecnica)
grayscale(img, max_gray_value)
cv2.imshow("madoka", img)
cv2.waitKey()
