import cv2
import sys
import numpy as np

DEFAULT_IMAGE = "../img/capitol.png"
filename = DEFAULT_IMAGE if len(sys.argv) == 1 else sys.argv[1]
filename = DEFAULT_IMAGE if len(sys.argv) == 1 else sys.argv[1]

def bug_local_equalization(image, grid_size):
    height, width = img.shape[:2]
    for y in range(0, height, grid_size/2):
        for x in range(0, width, grid_size/2):
            janela = image[y:y+grid_size, x:x+grid_size]
            hist = cv2.calcHist([janela], [0], None, [256], [0, 256])
            # "Cumulative Description Function" no histograma.
            cdfhist = np.cumsum(hist) / (grid_size ** 2)
            for i in range(0,256,1):
                janela[janela == i] = np.round(cdfhist[i] * 255);
            image[y:y+grid_size, x:x+grid_size] = janela
            cv2.rectangle(image, (x,y), (x+grid_size,y+grid_size), (255))
            cv2.imshow("Eric otaku", image)
            cv2.waitKey()

def local_equalization(image, grid_size):
    height, width = img.shape[:2]
    for x in range(0, width, grid_size):
        for y in range(0, height, grid_size):
            janela = image[y:y+grid_size, x:x+grid_size]
            hist = cv2.calcHist([janela], [0], None, [256], [0, 256])
            # "Cumulative Description Function" no histograma.
            cdfhist = np.cumsum(hist) / (grid_size ** 2)
            for i in range(0,256,1):
                janela[janela == i] = np.round(cdfhist[i] * 255);
            image[y:y+grid_size, x:x+grid_size] = janela

img = cv2.imread(filename, 0) 
if img is None:
    print "Deu ruim xd"
    sys.exit(1)
k_img = np.copy(img)
k2_img = np.copy(img)
ws = int(raw_input("Insira o tamanho da janela: "))
local_equalization(k_img, ws)
bug_local_equalization(k2_img, ws)

comp = raw_input("Deseja comparar o meu algoritmo com a equalizacao global e com a CLAHE[S/n]? ")
if comp != "n" and comp != "N":
    height, width = img.shape[:2]
    clahe = cv2.createCLAHE(tileGridSize=(width/ws, height/ws))
    cl_img = clahe.apply(img)
    eq_img = cv2.equalizeHist(img)
    cv2.imshow("CLAHE", cl_img)
    cv2.moveWindow("CLAHE", 0, img.shape[0] + 30) # + 30 = xunxo para aparecer o nome da janela
    cv2.imshow("Equalizacao Global", eq_img)
    cv2.moveWindow("Equalizacao Global", img.shape[1], 0)
cv2.imshow("Minha implementacao", k_img)
cv2.imshow("Minha implementacao 2", k2_img)
cv2.moveWindow("Minha implementacao", 0, 0)
cv2.moveWindow("Minha implementacao 2", img.shape[1], img.shape[0] + 30)
cv2.waitKey()
