import cv2
import sys
import numpy as np

DEFAULT_IMAGE = "../img/capitol.png"
filename = raw_input("Path para a imagem: ") if len(sys.argv) == 1 else sys.argv[1]
#filename = DEFAULT_IMAGE if len(sys.argv) == 1 else sys.argv[1]

def local_equalization(image, grid_size):
    height, width = img.shape[:2]
    for x in range(0, width, 1):
        for y in range(0, height, 1):
            start_x = 0 if x <= (grid_size/2) else x - grid_size/2 - (1 - grid_size%2)
            end_x = x + grid_size/2
            start_y = 0 if y <= (grid_size/2) else y - grid_size/2 - (1 - grid_size%2)
            end_y = y + grid_size/2
            janela = image[start_y:end_y, start_x:end_x]
            hist = cv2.calcHist([janela], [0], None, [256], [0, 256])
            # "Cumulative Description Function" no histograma.
            cdfhist = np.cumsum(hist) / (janela.shape[0] * janela.shape[1]) 
            janela[y-start_y,x-start_x] = np.round(cdfhist[janela[y-start_y,x-start_x]] * 255);
            image[start_y:end_y, start_x:end_x] = janela

img = cv2.imread(filename, 0) 
if img is None:
    print "Deu ruim xd"
    sys.exit(1)
k_img = np.copy(img)
ws = int(raw_input("Insira o tamanho da janela: "))
local_equalization(k_img, ws)
cv2.destroyAllWindows()

comp = raw_input("Deseja comparar o meu algoritmo com a equalizacao global e com a CLAHE[S/n]? ")
if comp != "n" and comp != "N":
    height, width = img.shape[:2]
    clahe = cv2.createCLAHE(tileGridSize=(width/ws, height/ws))
    cl_img = clahe.apply(img)
    eq_img = cv2.equalizeHist(img)
    cv2.imshow("CLAHE", cl_img)
    cv2.moveWindow("CLAHE", 0, img.shape[0] + 30) # + 30 = xunxo para aparecer o nome da janela
    cv2.imshow("Equalizacao Global", eq_img)
    cv2.moveWindow("Equalizacao Global", img.shape[1], 0)
cv2.imshow("Minha implementacao", k_img)
cv2.moveWindow("Minha implementacao", 0, 0)
cv2.waitKey()
